
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP实现文件上传下载实例_php实例 / iVAN</title>

    <meta name="description" content="PHP实现文件上传下载实例_php实例 本文介绍了PHP实现文件上传与下载,现在就分享给大家,也给大家做个参考.一起跟随小编过来看看吧. 一.上传原理与配置 1.1 原理 将客户端文件上传到服务器端,再将服务器端的文件(临时文件)移动到指定目录即可. 1.2 客户端配置 所需:表单页面(选择上传文件): 具体而言:发送方式为POST,添加enctype=&quot;multipart/form-data&quot;属性,两者缺一不可(但是,优缺点并存,这里也限定了上传的方式和上传的文件之后的调用等方面,后面会说到) &lt;!DOCT ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP实现文件上传下载实例_php实例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文介绍了PHP实现文件上传与下载，现在就分享给大家，也给大家做个参考。一起跟随小编过来看看吧。</p>
<p><strong>一、上传原理与配置</strong></p>
<p>1.1 原理</p>
<p>将客户端文件上传到服务器端，再将服务器端的文件（临时文件）移动到指定目录即可。</p>
<p>1.2 客户端配置</p>
<p>所需：表单页面（选择上传文件）；</p>
<p>具体而言：发送方式为POST，添加enctype="multipart/form-data"属性，两者缺一不可（但是，优缺点并存，这里也限定了上传的方式和上传的文件之后的调用等方面，后面会说到）</p>
<pre>
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;
&lt;html&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;
&lt;title&gt;Insert title here&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;form action="doAction.php" method="post" enctype="multipart/form-data"&gt;
请选择您要上传的文件：
&lt;input type="file" name="myFile" /&gt;&lt;br/&gt;
&lt;input type="submit" value="上传"/&gt;
&lt;/form&gt;
&lt;?php

?&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>
<p>先是表单页面（请自动忽略前端问题。。。），关键就是form的属性；另外就是input 中用到了type="file"这一点（体现到php的强大的拓展等等）。</p>
<p>然后是doAction</p>
<pre>
&lt;?php
//$_FILES:文件上传变量
//print_r($_FILES);
$filename=$_FILES['myFile']['name'];
$type=$_FILES['myFile']['type'];
$tmp_name=$_FILES['myFile']['tmp_name'];
$size=$_FILES['myFile']['size'];
$error=$_FILES['myFile']['error'];

//将服务器上的临时文件移动到指定位置
//方法一move_upload_file($tmp_name,$destination)
//move_uploaded_file($tmp_name, "uploads/".$filename);//文件夹应提前建立好，不然报错
//方法二copy($src,$des)
//以上两个函数都是成功返回真，否则返回false
//copy($tmp_name, "copies/".$filename);
//注意，不能两个方法都对临时文件进行操作，临时文件似乎操作完就没了，我们试试反过来
copy($tmp_name, "copies/".$filename);
move_uploaded_file($tmp_name, "uploads/".$filename);
//能够实现，说明move那个函数基本上相当于剪切；copy就是copy，临时文件还在

//另外，错误信息也是不一样的，遇到错误可以查看或者直接报告给用户
if ($error==0) {
  echo "上传成功！";
}else{
  switch ($error){
    case 1:
      echo "超过了上传文件的最大值，请上传2M以下文件";
      break;
    case 2:
      echo "上传文件过多，请一次上传20个及以下文件！";
      break;
    case 3:
      echo "文件并未完全上传，请再次尝试！";
      break;
    case 4:
      echo "未选择上传文件！";
      break;
    case 5:
      echo "上传文件为0";
      break;
  }
}
</pre>
<p>先把print_r($_FILES)这个信息看一下</p>
<pre>
Array
(
  [myFile] =&gt; Array
    (
      [name] =&gt; 梁博_简历.doc
      [type] =&gt; application/msword
      [tmp_name] =&gt; D:\wamp\tmp\php1D78.tmp
      [error] =&gt; 0
      [size] =&gt; 75776
    )

)
</pre>
<p>所以得到的是个二维数组，该怎么用，都是基本的东西（其实我喜欢降维再用）；</p>
<p>基本是一眼就懂的东西，不罗嗦，关键有两个：tmp_name临时文件名；error报错信息（代号，后面可以利用）；</p>
<p>然后这里看一下doAction后面一部分，利用报错信息来反馈给用户，需要说明的是为什么报错，和报错信息是什么都；</p>
<p>1.3 关于报错</p>
<p><strong>--报错原因:</strong></p>
<p>基本上都是超过或者不符合服务器关于上传文件的配置，那么服务器端配置有哪些呢？</p>
<p>先考虑上传我们用了什么？POST，upload</p>
<p>所以在php.ini中找这么几项：</p>
<p>file_upload:On</p>
<p>upload_tmp_dir=——临时文件保存目录；</p>
<p>upload_max_filesize=2M</p>
<p>max_file_uploads=20——允许一次上传的最大文件数量（注意和上面那个的区别，有没有size，别乱想）</p>
<p>post_max_size=8M——post方式发送数据的最大值</p>
<p><strong>其他相关配置</strong></p>
<p>max_exectuion_time=-1——最大执行时间，避免程序不好占用服务器资源；</p>
<p>max_input_time=60</p>
<p>max_input_nesting_level=64——输入嵌套深度；</p>
<p>memory_limit=128M——最大单线程的独立内存使用量</p>
<p>总之都是有关资源的配置。</p>
<p><strong>--错误号</strong></p>
<p>以下（偷懒）引自http://blog.sina.com.cn/s/blog_3cdfaea201008utf.html</p>
<ul>
<li>UPLOAD_ERR_OK             值：0; 没有错误发生，文件上传成功。</li>
<li>UPLOAD_ERR_INI_SIZE      值：1; 上传的文件超过了 php.ini 中 upload_max_filesize 选项限制的值。</li>
<li>UPLOAD_ERR_FORM_SIZE  值：2; 上传文件的大小超过了 HTML 表单中 MAX_FILE_SIZE 选项指定的值。</li>
<li>UPLOAD_ERR_PARTIAL          值：3; 文件只有部分被上传。</li>
<li>UPLOAD_ERR_NO_FILE          值：4; 没有文件被上传。 </li>
</ul>
<p>注意：这个错误信息是第一步上传的信息，也就是上传到临时文件夹的情况，而不是move或者copy的情况。</p>
<p><strong>二、上传相关限制</strong></p>
<p>2.1 客户端限制</p>
<pre>
&lt;form action="doAction2.php" method="post" enctype="multipart/form-data"&gt;
&lt;input type="hidden" name="MAX_FILE_SIZE" value="101321" /&gt;
</pre>
<p>请选择您要上传的文件：</p>
<pre>
&lt;input type="file" name="myFile" accept="image/jpeg,image/gif,text/html"/&gt;&lt;br/&gt;
&lt;input type="submit" value="上传"/&gt;
&lt;/form&gt;</pre>
<p>这里用input的属性对上传文件的大小和类型进行了限制，但是个人感觉：一，html代码是“可见的”；二，常不起作用（没找到原因，但因为第一个我也想放弃它，知道就好。</p>
<p> 2.2 服务器端限制</p>
<p>主要限制大小和类型，再有就是方式。</p>
<pre>
&lt;?php
header('content-type:text/html;charset=utf-8');
//接受文件，临时文件信息
$fileinfo=$_FILES["myFile"];//降维操作
$filename=$fileinfo["name"];
$tmp_name=$fileinfo["tmp_name"];
$size=$fileinfo["size"];
$error=$fileinfo["error"];
$type=$fileinfo["type"];

//服务器端设定限制
$maxsize=10485760;//10M,10*1024*1024
$allowExt=array('jpeg','jpg','png','tif');//允许上传的文件类型（拓展名
$ext=pathinfo($filename,PATHINFO_EXTENSION);//提取上传文件的拓展名

//目的信息
$path="uploads";
if (!file_exists($path)) {  //当目录不存在，就创建目录
  mkdir($path,0777,true);
  chmod($path, 0777);
}
//$destination=$path."/".$filename;
//得到唯一的文件名！防止因为文件名相同而产生覆盖
$uniName=md5(uniqid(microtime(true),true)).$ext;//md5加密，uniqid产生唯一id，microtime做前缀

if ($error==0) {
  if ($size&gt;$maxsize) {
    exit("上传文件过大！");
  }
  if (!in_array($ext, $allowExt)) {
    exit("非法文件类型");
  }
  if (!is_uploaded_file($tmp_name)) {
    exit("上传方式有误，请使用post方式");
  }
  if (@move_uploaded_file($tmp_name, $uniName)) {//@错误抑制符，不让用户看到警告
    echo "文件".$filename."上传成功!";
  }else{
    echo "文件".$filename."上传失败!";
  }
  //判断是否为真实图片（防止伪装成图片的病毒一类的
  if (!getimagesize($tmp_name)) {//getimagesize真实返回数组，否则返回false
    exit("不是真正的图片类型");
  }

}else{
  switch ($error){
    case 1:
      echo "超过了上传文件的最大值，请上传2M以下文件";
      break;
    case 2:
      echo "上传文件过多，请一次上传20个及以下文件！";
      break;
    case 3:
      echo "文件并未完全上传，请再次尝试！";
      break;
    case 4:
      echo "未选择上传文件！";
      break;
    case 7:
      echo "没有临时文件夹";
      break;
  }
}
这里，具体实现都有注释，每一步其实都可以自己
</pre>
<p>2.3 封装</p>
<p>函数</p>
<pre>
&lt;?php
function uploadFile($fileInfo,$path,$allowExt,$maxSize){

$filename=$fileInfo["name"];
$tmp_name=$fileInfo["tmp_name"];
$size=$fileInfo["size"];
$error=$fileInfo["error"];
$type=$fileInfo["type"];

//服务器端设定限制

$ext=pathinfo($filename,PATHINFO_EXTENSION);

//目的信息
if (!file_exists($path)) {
  mkdir($path,0777,true);
  chmod($path, 0777);
}
$uniName=md5(uniqid(microtime(true),true)).'.'.$ext;
$destination=$path."/".$uniName;

if ($error==0) {
  if ($size&gt;$maxSize) {
    exit("上传文件过大！");
  }
  if (!in_array($ext, $allowExt)) {
    exit("非法文件类型");
  }
  if (!is_uploaded_file($tmp_name)) {
    exit("上传方式有误，请使用post方式");
  }
  //判断是否为真实图片（防止伪装成图片的病毒一类的
  if (!getimagesize($tmp_name)) {//getimagesize真实返回数组，否则返回false
    exit("不是真正的图片类型");
  }
  if (@move_uploaded_file($tmp_name, $destination)) {//@错误抑制符，不让用户看到警告
    echo "文件".$filename."上传成功!";
  }else{
    echo "文件".$filename."上传失败!";
  }

}else{
  switch ($error){
    case 1:
      echo "超过了上传文件的最大值，请上传2M以下文件";
      break;
    case 2:
      echo "上传文件过多，请一次上传20个及以下文件！";
      break;
    case 3:
      echo "文件并未完全上传，请再次尝试！";
      break;
    case 4:
      echo "未选择上传文件！";
      break;
    case 7:
      echo "没有临时文件夹";
      break;
  }
}
return $destination;
}
</pre>
<p>调用</p>
<pre>
&lt;?php
header('content-type:text/html;charset=utf-8');
$fileInfo=$_FILES["myFile"];
$maxSize=10485760;//10M,10*1024*1024
$allowExt=array('jpeg','jpg','png','tif');
$path="uploads";
include_once 'upFunc.php';
uploadFile($fileInfo, $path, $allowExt, $maxSize);
</pre>
<p><strong>三、多文件的上传实现</strong></p>
<p>3.1 利用单文件封装</p>
<pre>
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;
&lt;html&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;
&lt;title&gt;Insert title here&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;form action="doAction5.php" method="post" enctype="multipart/form-data"&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile1" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile2" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile3" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile4" /&gt;&lt;br/&gt;
&lt;input type="submit" value="上传"/&gt;
&lt;/form&gt;
&lt;/body&gt;
&lt;/html&gt;
&lt;?php
//print_r($_FILES);
header('content-type:text/html;charset=utf-8');
include_once 'upFunc.php';
foreach ($_FILES as $fileInfo){
  $file[]=uploadFile($fileInfo);
}
</pre>
<p>这里的思路，从print_r($_FILES)中去找，打印出来看到是个二维数组，很简单，遍历去用就好了！</p>
<p>上面那个function的定义改一下，给定一些默认值</p>
<pre>
function uploadFile($fileInfo,$path="uploads",$allowExt=array('jpeg','jpg','png','tif'),$maxSize=10485760){</pre>
<p>这样子，简单是简单，但遇到一些问题。</p>
<p>正常的上传4个图片是没问题，但要是中间激活了函数中的exit，就会立即停止，导致其他图片也无法上传。</p>
<p>3.2 升级版封装</p>
<p>旨在实现针对多个或单个文件上传的封装</p>
<p>首先这样子写个静态文件</p>
<pre>
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;
&lt;html&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;
&lt;title&gt;Insert title here&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;form action="doAction5.php" method="post" enctype="multipart/form-data"&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile[]" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile[]" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile[]" /&gt;&lt;br/&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile[]" /&gt;&lt;br/&gt;
&lt;input type="submit" value="上传"/&gt;
&lt;/form&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>
<p>打印一下$_FILES</p>
<pre>
Array
(
  [myFile] =&gt; Array
    (
      [name] =&gt; Array
        (
          [0] =&gt; test32.png
          [1] =&gt; test32.png
          [2] =&gt; 333.png
          [3] =&gt; test41.png
        )

      [type] =&gt; Array
        (
          [0] =&gt; image/png
          [1] =&gt; image/png
          [2] =&gt; image/png
          [3] =&gt; image/png
        )

      [tmp_name] =&gt; Array
        (
          [0] =&gt; D:\wamp\tmp\php831C.tmp
          [1] =&gt; D:\wamp\tmp\php834C.tmp
          [2] =&gt; D:\wamp\tmp\php837C.tmp
          [3] =&gt; D:\wamp\tmp\php83BB.tmp
        )

      [error] =&gt; Array
        (
          [0] =&gt; 0
          [1] =&gt; 0
          [2] =&gt; 0
          [3] =&gt; 0
        )

      [size] =&gt; Array
        (
          [0] =&gt; 46174
          [1] =&gt; 46174
          [2] =&gt; 34196
          [3] =&gt; 38514
        )

    )

)
</pre>
<p>可以得到一个三维数组。</p>
<p>复杂是复杂了，但复杂的有规律，各项数值都在一起了，很方便我们取值！！</p>
<p>所以先得到文件信息，变成单文件处理那种信息</p>
<pre>
function getFiles(){
  $i=0;
  foreach($_FILES as $file){
    if(is_string($file['name'])){ //单文件判定
      $files[$i]=$file;
      $i++;
    }elseif(is_array($file['name'])){
      foreach($file['name'] as $key=&gt;$val){ //我的天，这个$key用的diao
        $files[$i]['name']=$file['name'][$key];
        $files[$i]['type']=$file['type'][$key];
        $files[$i]['tmp_name']=$file['tmp_name'][$key];
        $files[$i]['error']=$file['error'][$key];
        $files[$i]['size']=$file['size'][$key];
        $i++;
      }
    }
  }
  return $files;

}
</pre>
<p>然后之前的那种exit错误，就把exit改一下就好了，这里用res</p>
<pre>
function uploadFile($fileInfo,$path='./uploads',$flag=true,$maxSize=1048576,$allowExt=array('jpeg','jpg','png','gif')){
  //$flag=true;
  //$allowExt=array('jpeg','jpg','gif','png');
  //$maxSize=1048576;//1M
  //判断错误号
  $res=array();
  if($fileInfo['error']===UPLOAD_ERR_OK){
    //检测上传得到小
    if($fileInfo['size']&gt;$maxSize){
      $res['mes']=$fileInfo['name'].'上传文件过大';
    }
    $ext=getExt($fileInfo['name']);
    //检测上传文件的文件类型
    if(!in_array($ext,$allowExt)){
      $res['mes']=$fileInfo['name'].'非法文件类型';
    }
    //检测是否是真实的图片类型
    if($flag){
      if(!getimagesize($fileInfo['tmp_name'])){
        $res['mes']=$fileInfo['name'].'不是真实图片类型';
      }
    }
    //检测文件是否是通过HTTP POST上传上来的
    if(!is_uploaded_file($fileInfo['tmp_name'])){
      $res['mes']=$fileInfo['name'].'文件不是通过HTTP POST方式上传上来的';
    }
    if($res) return $res;
    //$path='./uploads';
    if(!file_exists($path)){
      mkdir($path,0777,true);
      chmod($path,0777);
    }
    $uniName=getUniName();
    $destination=$path.'/'.$uniName.'.'.$ext;
    if(!move_uploaded_file($fileInfo['tmp_name'],$destination)){
      $res['mes']=$fileInfo['name'].'文件移动失败';
    }
    $res['mes']=$fileInfo['name'].'上传成功';
    $res['dest']=$destination;
    return $res;

  }else{
    //匹配错误信息
    switch ($fileInfo ['error']) {
      case 1 :
        $res['mes'] = '上传文件超过了PHP配置文件中upload_max_filesize选项的值';
        break;
      case 2 :
        $res['mes'] = '超过了表单MAX_FILE_SIZE限制的大小';
        break;
      case 3 :
        $res['mes'] = '文件部分被上传';
        break;
      case 4 :
        $res['mes'] = '没有选择上传文件';
        break;
      case 6 :
        $res['mes'] = '没有找到临时目录';
        break;
      case 7 :
      case 8 :
        $res['mes'] = '系统错误';
        break;
    }
    return $res;
  }
}
</pre>
<p>里面封装了两个小的</p>
<pre>
function getExt($filename){
  return strtolower(pathinfo($filename,PATHINFO_EXTENSION));
}

/**
 * 产生唯一字符串
 * @return string
 */
function getUniName(){
  return md5(uniqid(microtime(true),true));
}
</pre>
<p>然后静态中，用multiple属性实现多个文件的输入；</p>
<pre>
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;
&lt;html&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;
&lt;title&gt;Insert title here&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;form action="doAction6.php" method="POST" enctype="multipart/form-data"&gt;
请选择您要上传的文件：&lt;input type="file" name="myFile[]" multiple='multiple' /&gt;&lt;br/&gt;
&lt;input type="submit" value="上传"/&gt;
&lt;/form&gt;
&lt;/body&gt;
&lt;/html&gt;
doAction6
&lt;?php
//print_r($_FILES);
header("content-type:text/html;charset=utf-8");
require_once 'upFunc2.php';
require_once 'common.func.php';
$files=getFiles();
// print_r($files);
foreach($files as $fileInfo){
  $res=uploadFile($fileInfo);
  echo $res['mes'],'&lt;br/&gt;';
  $uploadFiles[]=@$res['dest'];
}
$uploadFiles=array_values(array_filter($uploadFiles));
//print_r($uploadFiles);
</pre>
<p>这样子的几个文件，就实现比较强大的面向过程的上传文件的功能（学的叫一个心酸。。。）；</p>
<p>四、面向对象的文件上传</p>
<pre>
&lt;?php
class upload{
  protected $fileName;
  protected $maxSize;
  protected $allowMime;
  protected $allowExt;
  protected $uploadPath;
  protected $imgFlag;
  protected $fileInfo;
  protected $error;
  protected $ext;
  /**
   * @param string $fileName
   * @param string $uploadPath
   * @param string $imgFlag
   * @param number $maxSize
   * @param array $allowExt
   * @param array $allowMime
   */
  public function __construct($fileName='myFile',$uploadPath='./uploads',$imgFlag=true,$maxSize=5242880,$allowExt=array('jpeg','jpg','png','gif'),$allowMime=array('image/jpeg','image/png','image/gif')){
    $this-&gt;fileName=$fileName;
    $this-&gt;maxSize=$maxSize;
    $this-&gt;allowMime=$allowMime;
    $this-&gt;allowExt=$allowExt;
    $this-&gt;uploadPath=$uploadPath;
    $this-&gt;imgFlag=$imgFlag;
    $this-&gt;fileInfo=$_FILES[$this-&gt;fileName];
  }
  /**
   * 检测上传文件是否出错
   * @return boolean
   */
  protected function checkError(){
    if(!is_null($this-&gt;fileInfo)){
      if($this-&gt;fileInfo['error']&gt;0){
        switch($this-&gt;fileInfo['error']){
          case 1:
            $this-&gt;error='超过了PHP配置文件中upload_max_filesize选项的值';
            break;
          case 2:
            $this-&gt;error='超过了表单中MAX_FILE_SIZE设置的值';
            break;
          case 3:
            $this-&gt;error='文件部分被上传';
            break;
          case 4:
            $this-&gt;error='没有选择上传文件';
            break;
          case 6:
            $this-&gt;error='没有找到临时目录';
            break;
          case 7:
            $this-&gt;error='文件不可写';
            break;
          case 8:
            $this-&gt;error='由于PHP的扩展程序中断文件上传';
            break;

        }
        return false;
      }else{
        return true;
      }
    }else{
      $this-&gt;error='文件上传出错';
      return false;
    }
  }
  /**
   * 检测上传文件的大小
   * @return boolean
   */
  protected function checkSize(){
    if($this-&gt;fileInfo['size']&gt;$this-&gt;maxSize){
      $this-&gt;error='上传文件过大';
      return false;
    }
    return true;
  }
  /**
   * 检测扩展名
   * @return boolean
   */
  protected function checkExt(){
    $this-&gt;ext=strtolower(pathinfo($this-&gt;fileInfo['name'],PATHINFO_EXTENSION));
    if(!in_array($this-&gt;ext,$this-&gt;allowExt)){
      $this-&gt;error='不允许的扩展名';
      return false;
    }
    return true;
  }
  /**
   * 检测文件的类型
   * @return boolean
   */
  protected function checkMime(){
    if(!in_array($this-&gt;fileInfo['type'],$this-&gt;allowMime)){
      $this-&gt;error='不允许的文件类型';
      return false;
    }
    return true;
  }
  /**
   * 检测是否是真实图片
   * @return boolean
   */
  protected function checkTrueImg(){
    if($this-&gt;imgFlag){
      if(!@getimagesize($this-&gt;fileInfo['tmp_name'])){
        $this-&gt;error='不是真实图片';
        return false;
      }
      return true;
    }
  }
  /**
   * 检测是否通过HTTP POST方式上传上来的
   * @return boolean
   */
  protected function checkHTTPPost(){
    if(!is_uploaded_file($this-&gt;fileInfo['tmp_name'])){
      $this-&gt;error='文件不是通过HTTP POST方式上传上来的';
      return false;
    }
    return true;
  }
  /**
   *显示错误
   */
  protected function showError(){
    exit('&lt;span style="color:red"&gt;'.$this-&gt;error.'&lt;/span&gt;');
  }
  /**
   * 检测目录不存在则创建
   */
  protected function checkUploadPath(){
    if(!file_exists($this-&gt;uploadPath)){
      mkdir($this-&gt;uploadPath,0777,true);
    }
  }
  /**
   * 产生唯一字符串
   * @return string
   */
  protected function getUniName(){
    return md5(uniqid(microtime(true),true));
  }
  /**
   * 上传文件
   * @return string
   */
  public function uploadFile(){
    if($this-&gt;checkError()&amp;&amp;$this-&gt;checkSize()&amp;&amp;$this-&gt;checkExt()&amp;&amp;$this-&gt;checkMime()&amp;&amp;$this-&gt;checkTrueImg()&amp;&amp;$this-&gt;checkHTTPPost()){
      $this-&gt;checkUploadPath();
      $this-&gt;uniName=$this-&gt;getUniName();
      $this-&gt;destination=$this-&gt;uploadPath.'/'.$this-&gt;uniName.'.'.$this-&gt;ext;
      if(@move_uploaded_file($this-&gt;fileInfo['tmp_name'], $this-&gt;destination)){
        return $this-&gt;destination;
      }else{
        $this-&gt;error='文件移动失败';
        $this-&gt;showError();
      }
    }else{
      $this-&gt;showError();
    }
  }
}
&lt;?php
header('content-type:text/html;charset=utf-8');
require_once 'upload.class.php';
$upload=new upload('myFile1','imooc');
$dest=$upload-&gt;uploadFile();
echo $dest;
</pre>
<p>四、下载</p>
<p>对于浏览器不识别的，可以直接下载，但对于能识别的，需要多一两步</p>
<pre>
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html xmlns="http://www.w3.org/1999/xhtml"&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /&gt;
&lt;title&gt;Insert title here&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;a href="1.rar"&gt;下载1.rar&lt;/a&gt;
&lt;br /&gt;
&lt;a href="1.jpg"&gt;下载1.jpg&lt;/a&gt;
&lt;br /&gt;
&lt;a href="doDownload.php?filename=1.jpg"&gt;通过程序下载1.jpg&lt;/a&gt;
&lt;br /&gt;
&lt;a href="doDownload.php?filename=../upload/nv.jpg"&gt;下载nv.jpg&lt;/a&gt;
&lt;?php

?&gt;
&lt;/body&gt;
&lt;/html&gt;
&lt;?php
$filename=$_GET['filename'];
header('content-disposition:attachment;filename='.basename($filename));
header('content-length:'.filesize($filename));
readfile($filename);
</pre>
<p>感谢阅读，希望能帮助到大家，谢谢大家对本站的支持！</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索php<br />
                    ，                文件上传<br />
                                    php文件上传下载<br />
                                    php文件上传实例、php 文件上传实例代码、php文件上传实例详解、php文件上传下载 实例、php实现文件上传，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 11:04:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6%e4%b8%8a%e4%bc%a0/" title="文件上传">文件上传</a>, <a href="https://www.iamivan.net/tag/php%e6%96%87%e4%bb%b6%e4%b8%8a%e4%bc%a0%e4%b8%8b%e8%bd%bd/" title="php文件上传下载">php文件上传下载</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP实现文件上传下载实例_php实例的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvLEoM.html" rel="bookmark">Java文件上传下载、邮件收发实例代码&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文件上传下载 前台: 1. 提交方式:post 2. 表单中有文件上传的表单项: &lt;input type=&quot;file&quot; /&gt; 3. 指定表单类型: 默认类型:enctype=&quot;application/x-www-form-urlencoded&quot; 文件上传类型:multipart/form-data FileUpload 文件上传功能开发中比较常用,apache也提供了文件上传组件! FileUpload组件: 1. 下载源码 2. 项目中引入jar文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6we2b.html" rel="bookmark">一个经典的PHP文件上传类分享&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文件上传是项目开发中比较常见的功能,但文件上传的过程比较繁琐,只要是有文件上传的地方就需要编写这些复杂的代码.为了能在每次开发中降低功能的编写难度,也为了能节省开发时间,通常我们都会将这些反复使用的一段代码封装到一个类中.帮助开发者在以后的开发中,通过编写几条简单代码就可以实现复杂的文件上传功能.对于基础薄弱的读者,只要会使用本类即可,而对一些喜欢挑战的朋友,可以尝试去读懂它,并能开发一个属于自己的文件上传类. 一.需求分析 要球自定义文件上传类,即在使用非常简便的前提下,又可以完成以下几项功能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6QZPM.html" rel="bookmark">ThinkPHP结合AjaxFileUploader实现无刷新文件上传的方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了ThinkPHP结合AjaxFileUploader实现无刷新文件上传的方法.分享给大家供大家参考.具体实现方法分析如下: 首先,AjaxFileUploader插件是一个基于jquery的插件,我们可以使用AjaxFileUploader插件来实现文件异步上传功能了,使用这款插件上传文件不要担心兼容性的问题,它的兼容性可以说兼容所有主流浏览器,下面来给大家介绍一个AjaxFileUploader+thinkphp实现文件上传的实例. ThinkPHP框架下用AjaxFileUpl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z441d9z.html" rel="bookmark">thinkPHP3&period;2简单实现文件上传的方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了thinkPHP3.2简单实现文件上传的方法.分享给大家供大家参考,具体如下: IndexController.class.php: &lt;?php namespace Home\Controller; use Think\Controller; class IndexController extends Controller { function index(){ $this-&gt;display(); } public function upload(){ $upload = new			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N1dxp.html" rel="bookmark">Thinkphp多文件上传实现方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Thinkphp多文件上传实现方法,分享给大家供大家参考.具体实现方法如下: Thinkphp手册中对于多文件上传描述的很清楚:如果需要使用多个文件,只需要修改表单,把 复制代码 代码如下: &lt;input type='file' name='photo'&gt; 改为 复制代码 代码如下: &lt;li&gt;&lt;input type='file' name='photo1'&gt;&lt;/li&gt; &lt;li&gt;&lt;input type='file' name='			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2WowBM.html" rel="bookmark">PHP 图片文件上传实现代码&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了网站的安全,肯定不让上传php文件,如果有人进入你的后台,上传了一个php文件,你的网站源码,全部救变成他的了,直接打包看你的代码.所以一定要控制上传的目录与文件类型,一般只可以上传图片. 创建一个文件上传表单 允许用户从表单上传文件是非常有用的. 请看下面这个供上传文件的 HTML 表单: 复制代码 代码如下: &lt;html&gt; &lt;body&gt; &lt;form action=&quot;upload_file.php&quot; method=&quot;post&quot; e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKDREz.html" rel="bookmark">php多文件上传实现代码&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				index_uploads.php 复制代码 代码如下: &lt;html&gt;&lt;head&gt;    &lt;meta charset=&quot;utf-8&quot;&gt;    &lt;title&gt;index_uploads&lt;/title&gt;&lt;/head&gt;&lt;body&gt;    &lt;form action=&quot;uploads.php&quot; method=&quot;post&quot; enctype=&quot;multipart			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR191xb.html" rel="bookmark">codeigniter教程之多文件上传使用示例&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: &lt;?php if(!defined(&quot;BASEPATH&quot;)){ exit(&quot;No direct script access allowed&quot;); }  /**  * Multi-Upload  *   * Extends CodeIgniters native Upload class to add support for multiple  * uploads.  *  * @package  CodeIgniter  * @subpa			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2ZWekb.html" rel="bookmark">JavaWeb文件上传下载实例讲解&lpar;酷炫的文件上传技术&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.课程概述 在Web应用系统开发中,文件上传功能是非常常用的功能,今天来主要讲讲JavaWeb中的文件上传功能的相关技术实现,并且随着互联网技术的飞速发展,用户对网站的体验要求越来越高,在文件上传功能的技术上也出现许多创新点,例如异步上传文件,拖拽式上传,黏贴上传,上传进度监控,文件缩略图,大文件断点续传,大文件秒传等等. 本课程需要的基础知识: 了解基本的Http协议内容 基本IO流操作技术 Servlet基础知识 javascript/jQuery技术基础知识 二.文件上传的基础 对于文件			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b30gMA.html" rel="bookmark" class="title">怎么把cda转成mp3？</a>
					<div>
						  1.启动系统自带的windows media player. 2.点击&quot;翻录&quot;,播放器会提示你插入CD光盘.插入CD光盘后,会出现曲目列表. 3.转换前,再次点击&quot;翻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx25yz.html" rel="bookmark" class="title">部分链表操作总结</a>
					<div>
						部分链表操作总结 #include &lt;iostream&gt; #include &lt;cstdlib&gt; using namespace std; // definition of No ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM692Ab.html" rel="bookmark" class="title">网站运营，站长必须解决的七大瓶颈&excl;</a>
					<div>
						解决|站长|网站运营|瓶颈 许多站长在网站发展的每个阶段,都会遇到不同的难点,本文从以下七个方面分析如何突破网站的阶段性瓶颈问题. 一.网站定位瓶颈 网站建设之初,往往出现的就是定位问题.网站定位的模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMymwlM.html" rel="bookmark" class="title">用CSS把标题超出的部分变成&period;&period;&period;</a>
					<div>
						核心提示:用CSS把标题超出的部分变成... &lt;html&gt; &lt;body&gt; &lt;style&gt; .ellipsis span {    white-space:nowra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg9KOz.html" rel="bookmark" class="title">Photoshop教程06：Photoshop6倒转乾坤</a>
					<div>
						教程 倒转乾坤?没有这么夸张吧?Wrong!Photoshop真的可以!让玉米哥来告诉你们吧.图片一开始就符合要求得情况是很少有的.把一幅图片中得对象复制到另外一幅图片中时,经常要把它放大或者缩小.也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkoyrp.html" rel="bookmark" class="title">从5个方面来探讨商城类网站的SEO效果</a>
					<div>
						随着互联网的发展,商城类网站越来越多的出现在我们的视野中,这些商场类网站既包括B2C商城,也包括大家做的大型淘宝客网站,这些网站由于自己的特点,所以在优化的时候也有一些技巧和注意的事项,今天我和大家分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY29eBp.html" rel="bookmark" class="title">Symbian学习笔记&lpar;1&rpar;&mdash;&mdash;Debug On Device</a>
					<div>
						在BREW的开发环境中,没有一个联机调试工具,一直是我觉得相当不方便的事情.在S60平台上做开发,至少这一点是能满足我们的需要. 第一种方法:Carbide C++ v1.2 的 Debug On D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxDkAb.html" rel="bookmark" class="title">怎么用搜狗拼音的手写输入法</a>
					<div>
						搜狗拼音是很多朋友在电脑打字的喜爱输入法,但其中的扩展手写输入功能,可能有好多朋友不太清楚啊.希望在此做个教程,有兴趣的朋友看看吧,呵呵. 第一步:你的电脑肯定要安装有搜狗拼音,并且切换到此输入法状态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl2e8b.html" rel="bookmark" class="title">Linux系统下获取主板信息的方法</a>
					<div>
						  dmidecode取出的信息可能不是主板的唯一标识吧,我试一下 /usr/sbin/dmidecode | grep &quot;Serial Number&quot; 在DELL的下面显示: S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6V4dz.html" rel="bookmark" class="title">win7系统没有声音解决方法</a>
					<div>
						为使用本本教程时获得最佳效果,请务必在完 成每一步之后再移至下一步.在完成上一步之后,先检查声音,然后再继续执行下一步. 工具/原料win7自带疑难解答工具 驱动精灵 步骤/方法步骤 一:检查硬件 许 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwZqQz.html" rel="bookmark" class="title">IE8提示此选项卡已经恢复的修复方法</a>
					<div>
						  用IE8浏览部分网站时出现&quot;此选项卡已经恢复&quot;.打开百度.新浪等网站时是正常的,但是打开凤凰网和搜狐,或者或单击了网站上的某个超链接之后便会出此问题,访问该页面的IE选项卡老是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Ywvp.html" rel="bookmark" class="title">Photoshop调出风景照片柔美的橙蓝色</a>
					<div>
						教程的色调以常用的蓝色及橙色为主.调色的时候把远景调成较深的蓝色,前景则调成鲜艳的橙黄色.有种冷暖对比的感觉. 原图 最终效果 1.打开原图素材,按Ctrl + J 把背景图层复制一层,执行:图像 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL8lvb.html" rel="bookmark" class="title">安卓模拟器无法安装&OpenCurlyDoubleQuote;系统opengl版本过低&rdquo;的通用解决方法</a>
					<div>
						  在安装安卓模拟器时,出现&quot;系统opengl版本过低&quot;,下图提示,说明你的显卡暂不支持模拟器: 遇到这个问题,主要是3种原因 1.你的电脑没有显卡 解决方案:这个问题若不换电脑硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze75BwM.html" rel="bookmark" class="title">jsp 获取session中数据</a>
					<div>
						问题描述 jsp 获取session中数据 后台: HttpServletRequest request = ((ServletRequestAttributes) RequestContextHol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdNPkM.html" rel="bookmark" class="title">7&period;1&period;5 选项卡结合案例详解</a>
					<div>
						选项卡是通过TabHost和TabActivity一起实现的,TabHost是Android中很常用的布局之一,它的标签可以有文本和文本图片样式.点击不同标签还可以切换标签.TabHost类的继承图如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8REqp.html" rel="bookmark" class="title">&period;NET 缓存设计的使用说明&lowbar;实用技巧</a>
					<div>
						关于缓存的设计1.什么情况下用缓存 缓存是提高应用程序性能的最好方法之一.运用缓存可以优化数据查询,避免不必要的网络数据回传,和避免执行不必要的完全相同的数据处理逻辑.在实现缓存的时候我们要确定什么时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw41jp.html" rel="bookmark" class="title">php获取随机数组列表的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php获取数组中随机数组的实例程序,分享给大家供大家参考.具体实现方法如下: 不用多说,直接贴代码,php中的array_rand很变态,突破了正常人的理解,非常繁琐 例1: 复制代码  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze64BVb.html" rel="bookmark" class="title">directShow如何提取视频中的音频，并将视频和音频同步？directShow如何提取音频</a>
					<div>
						问题描述 directShow如何提取视频中的音频,并将视频和音频同步?directShow如何提取音频 directShow如何提取视频中的音频,并将视频和音频同步?directShow如何提取音频 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjNarp.html" rel="bookmark" class="title">关于GetAllDocumentsByKey的问题</a>
					<div>
						问题描述 假设有一个视图,前两列做了分类排序部门性别姓名年龄人事部男张三29李一30女刘五24财务部女赵一25马七29使用以下代码DimsessionAsNewNotesSessionDimdbAsN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6l3xb.html" rel="bookmark" class="title">android自定义属性</a>
					<div>
						1.引言 对于自定义属性,大家肯定都不陌生,遵循以下几步,就可以实现: 自定义一个CustomView(extends View )类 编写values/attrs.xml,在其中编写styleabl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrykAM.html" rel="bookmark" class="title">AMD要闹哪样！亮出无字天书路线图</a>
					<div>
						产品规划路线图平常见的多了去了,但如此奇葩的还是头一次碰到.在近日的一次高性能计算会议上,AMD展示了这么一张有关Opteron服务器处理器的路线图: 是不是有点看到了无字天书的感觉?关键是,AMD也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YVoXM.html" rel="bookmark" class="title">Git常用命令备忘</a>
					<div>
						今天,慕课网小编为大家带来robbin分享的Git常用命令,希望对学习Git的朋友们有所帮助,喜欢的快在微博中马起来吧! Git配置 git config --global user.name &qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydKAvb.html" rel="bookmark" class="title">springboot&lpar;十四&rpar;：springboot整合shiro-登录认证和权限管理</a>
					<div>
						这篇文章我们来学习如何使用Spring Boot集成Apache Shiro.安全应该是互联网公司的一道生命线,几乎任何的公司都会涉及到这方面的需求.在Java领域一般有Spring Security ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40Gy1z.html" rel="bookmark" class="title">如何把本地文件包含变为远程文件包含漏洞</a>
					<div>
						本文讲的是如何把本地文件包含变为远程文件包含漏洞, 本地文件包含(LFI)在Web渗透测试中时不时的会遇到,通过加强对LFI渗透测试技术的研究,可以帮助渗透测试人员在未来的渗透测试过程中,识别和测试L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkerGOb.html" rel="bookmark" class="title">用什么样的语言就有什么样的公司</a>
					<div>
						想知道语言的威力有多大,可以看看&lt;通天塔-17&gt;.里面星际战争的一方只需让另一方学习了一门语言,即让对方弃明投暗.编程语言也具有类 似的威力,它赋予了软件公司重塑自我的能力,它不仅能改变问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0gNnM.html" rel="bookmark" class="title">动态网页的搜索引擎优化-搜索引擎技术</a>
					<div>
						动态生成的网页: 对于那些动态生成网页,我们这些实际的访问者可以通过肉眼看到.但对于大多数搜索引擎的蜘蛛程序却往往是不可见的,这也就是动态网页很难被搜索引擎的SPIDER检索的原因.因而,要想让你的动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZ0Znp.html" rel="bookmark" class="title">警官微博低姿态现身</a>
					<div>
						&quot;不是五毛,拒绝马甲,我是Leif,省厅刘警官,祝大家新年快乐,喜乐安康!&quot;新年第一天, 网友们惊喜地发现,广东省公安厅网站的&quot;刘警官&quot;现身了!他和他的工作团队 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLl1LM.html" rel="bookmark" class="title">apns可以设置自定义声音么</a>
					<div>
						问题描述 请问一下apns可以设置自定义声音么?(iOS) 解决方案 环信的推送不支持自定义,只可以设置开和关,不可以自定义声音,如果有需要可以使用第三方的推送.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgr3kM.html" rel="bookmark" class="title">网络安全法实施 个人信息保护立法还需做什么</a>
					<div>
						我国对于个人信息的保护越来越严格.从6月1日起,最高人民法院.最高人民检察院联合发布的&lt;关于办理侵犯公民个人信息刑事案件适用法律若干问题的解释&gt;(以下简称&quot;两高司法解释&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRkaKp.html" rel="bookmark" class="title">数据中心分析诊断必备之常用仪表</a>
					<div>
						俗话说:&quot;巧妇难为无米之炊&quot;,要想对数据中心做深入的剖析,必须要有一套行之有效的仪表工具才行,通过利用这些仪表获取数据中心运行的各种参数,以便通过这些参数来分析问题.很多时候,由于 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
